from ls_sec.core import LSAPI

_BASE = {
    "/futureoption/market-data": {
        "선물/옵션현재가(시세)조회": "t2101",
        "선물/옵션현재가호가조회": "t2105",
        "선물/옵션현재가시세메모": "t2106",
        "선물옵션시간대별체결조회": "t2201",
        "기간별주가": "t2203",
        "선물옵션시간대별체결조회(단일출력용)": "t2210",
        "옵션전광판": "t2301",
        "선물옵션호가잔량비율챠트": "t2405",
        "미결제약정추이": "t2421",
        "EUREXKOSPI200옵션선물현재가(시세)조회": "t2830",
        "EUREXKOSPI200옵션선물호가조회": "t2831",
        "EUREX야간옵션선물시간대별체결조회": "t2832",
        "EUREX야간옵션선물기간별추이": "t2833",
        "EUREX옵션선물시세전광판": "t2835",
        "주식선물마스터조회(API용)": "t8401",
        "주식선물현재가조회(API용)": "t8402",
        "주식선물호가조회(API용)": "t8403",
        "주식선물시간대별체결조회(API용)": "t8404",
        "주식선물기간별주가(API용)": "t8405",
        "주식선물틱분별체결조회(API용)": "t8406",
        "상품선물마스터조회(API용)": "t8426",
        "과거데이터시간대별조회": "t8427",
        "지수선물마스터조회API용": "t8432",
        "지수옵션마스터조회API용": "t8433",
        "선물/옵션멀티현재가조회": "t8434",
        "파생종목마스터조회API용": "t8435",
        "CME/EUREX마스터조회(API용)": "t8437",
        "지수선물마스터조회API용1": "t9943",
        "지수옵션마스터조회API용1": "t9944",
    },
    "/futureoption/investor": {
        "상품선물투자자매매동향(실시간)": "t2541",
        "상품선물투자자매매동향(챠트용)": "t2545",
    },
    "/futureoption/chart": {
        "선물옵션틱분별체결조회차트": "t2209",
        "선물옵션차트(틱/n틱)": "t8414",
        "선물/옵션차트(N분)": "t8415",
        "선물/옵션차트(일주월)": "t8416",
        "EUREX야간옵션선물틱분별체결조회차트": "t8429",
    },
    "/futureoption/accno": {
        "선물옵션 계좌 주문체결내역 조회": "CFOAQ00600",
        "선물옵션 계좌잔고 및 평가현황3": "CFOAQ50600",
        "선물옵션 주문가능수량조회": "CFOAQ10100",
        "선물옵션 계좌예탁금증거금조회": "CFOBQ10500",
        "선물옵션가정산예탁금상세": "CFOEQ11100",
        "선물옵션 일별 계좌손익내역": "CFOEQ82600",
        "계좌 미결제 약정현황(평균가)": "CFOFQ02400",
        "선물/옵션체결/미체결": "t0434",
        "선물/옵션잔고평가(이동평균)": "t0441",
        "EUREX 주문체결내역조회": "CEXAQ21100",
        "EUREX 주문가능 수량/금액 조회": "CEXAQ21200",
        "EUREX 야간장잔고및 평가현황": "CEXAQ31100",
        "EUREX 예탁금 및 통합잔고조회": "CEXAQ31200",
        "EUREX 야간옵션 기간주문체결조회": "CEXAQ44200",
        "선물옵션 기간별 계좌 수익률 현황": "FOCCQ3370",
    },
    "/futureoption/order": {
        "선물옵션 정상주문": "CFOAT00100",
        "선물옵션 정정주문": "CFOAT00200",
        "선물옵션 취소주문": "CFOAT00300",
        "선물옵션 옵션매도시 주문증거금조회(옵션매도시 1계약당 주문증거금)": "CFOBQ10800",
        "EUREX 매수/매도주문": "CEXAT11100",
        "EUREX 정정주문": "CEXAT11200",
        "EUREX 취소주문": "CEXAT1130",
    },
    "/futureoption/etc": {
        "파생상품증거금율조회": "MMDAQ9120",
    },
}


class LSDerivatives(LSAPI):
    def __init__(self, key, secret):
        super().__init__(key, secret)

    # markets
    from ls_sec.derivatives._market import (
        cme_eurex_master,
        current_memo,
        current_ohlcv,
        current_orderbook,
        derivatives_master,
        get_eurex_board,
        get_eurex_historical,
        get_eurex_ohlcv,
        get_eurex_orderbook,
        get_eurex_trade,
        get_historical_ohlcv,
        get_trade_single,
        historical_ohlcv,
        index_futures_master,
        index_options_master,
        multi_ohlc,
        open_interest,
        options_board,
        order_balance,
        product_master,
        stock_futures_current,
        stock_futures_historical_ohlcv,
        stock_futures_master,
        stock_futures_orderbook,
        stock_futures_tick_historical,
        stock_futures_trade_iter,
        trade_iter,
    )
